 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 * *
 * @version 2014-03-13
 */

public class ArztpraxisMitBDController {
  private Arztpraxis2View praxisGUI;
  private Queue<Patient> wzimmer;
  private Queue<Patient> wbdmessung;
  private Patient wirdBehandelt;

  public ArztpraxisMitBDController() {
    praxisGUI = new Arztpraxis2View();
    wzimmer = new Queue<Patient>();
    wbdmessung = new Queue<Patient>();
    wirdBehandelt = null;
    praxisGUI.setzeArztpraxisController(this);
    praxisGUI.setVisible(true);
  }

  public void bearbeiteAnmeldungSprechzimmer(String name, String kasse) {
    Patient neu = new Patient(name, kasse);
    if (wzimmer.isEmpty()) {
      praxisGUI.setzeNaechster(name + " " + kasse);
    }
    wzimmer.enqueue(neu);
  }

  public void bearbeiteNaechsterPatient() {
    praxisGUI.leereSprechzimmer();
    wirdBehandelt = null;
    if (wzimmer.isEmpty()) {
      praxisGUI.zeigeMeldung("Das Wartezimmer ist leer");
    } else {
        wirdBehandelt = wzimmer.front();
        praxisGUI.setzeInsSprechzimmer(wirdBehandelt.gibName() + " "
        + wirdBehandelt.gibKasse());
        wzimmer.dequeue();
        if (wzimmer.isEmpty()) {
        praxisGUI.setzeNaechster("-");
         } else 
           praxisGUI.setzeNaechster(wzimmer.front().gibName() + " "
          + wzimmer.front().gibKasse());
    }  
  }

  /**
   * @param args
   */
  public static void main(String[] args) {
    new ArztpraxisMitBDController();
  }

  /**
   * @param name
   * @param kasse
   */
  public void bearbeiteAnmeldungSprechzimmerUndBlutdruckmessung(String name,
      String kasse) {
    Patient neu = new Patient(name, kasse);
    if (wzimmer.isEmpty()) {
      praxisGUI.setzeNaechster(name + " " + kasse);
    }
    if (wbdmessung.isEmpty()) {
      praxisGUI.setzeNaechsterBD(name + " " + kasse);
    }
    wzimmer.enqueue(neu);
    wbdmessung.enqueue(neu);
  }

  /**
   * 
   */
  public void bearbeiteNaechsteMessung() {
    if (wbdmessung.isEmpty()) {
      praxisGUI
          .zeigeMeldung("Es gibt keinen Patienten f??r die Blutdruckmessung.");
      return;
    }
    Patient dran = wbdmessung.front();
    wbdmessung.dequeue();
    if (dran == wirdBehandelt) {
      praxisGUI
          .zeigeMeldung("Der Patient "
              + wirdBehandelt.gibName()
              + " "
              + wirdBehandelt.gibKasse()
              + " wird \ngerade behandelt. Die Blutdruckmessung erfolgt direkt im Anschluss.");     
    } else {
      praxisGUI
      .zeigeMeldung("Der Blutdruck des Patienten "
          + dran.gibName()
          + " "
          + dran.gibKasse()
          + " wurde gemessen");
    }
    praxisGUI.setzeNaechsterBD("-");
    if (!wbdmessung.isEmpty()) {
      praxisGUI.setzeNaechsterBD(wbdmessung.front().gibName() + " "
          + wbdmessung.front().gibKasse());
    }

  }

}
